diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/examples/fd-emu-tc.cc ns-3.32/src/fd-net-device/examples/fd-emu-tc.cc
--- ns-3.31/src/fd-net-device/examples/fd-emu-tc.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/fd-net-device/examples/fd-emu-tc.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,314 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Pasquale Imputato <p.imputato@gmail.com>
+ */
+
+/*
+ *                                          node
+ *                     --------------------------------------------------
+ *                     |                                                |
+ *                     |        pfifo_fast    queueDiscType [pfifo_fast]|
+ *                     |                      bql [false]               |
+ *                     |        interface 0   interface 1               |
+ *                     |             |             |                    |
+ *                     --------------------------------------------------
+ *                                   |             |
+ *   1 Gbps access incoming link     |             |           100 Mbps bottleneck outgoing link
+ * -----------------------------------             -----------------------------------
+ *
+ * This example builds a node with two interfaces in emulation mode in 
+ * either {raw, netmap}. The aim is to explore different qdiscs behaviours 
+ * on the backlog of a device emulated bottleneck side.
+ *
+ * If you run emulation in netmap mode, you need before to load the 
+ * netmap.ko module.  The user is responsible for configuring and building
+ * netmap separately.
+ */
+
+#include "ns3/abort.h"
+#include "ns3/core-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/network-module.h"
+#include "ns3/fd-net-device-module.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/ipv4-list-routing-helper.h"
+#include "ns3/traffic-control-module.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("TrafficControlEmu");
+
+void
+TcPacketsInQueue (Ptr<QueueDisc> q, Ptr<OutputStreamWrapper> stream)
+{
+  Simulator::Schedule (Seconds (0.001), &TcPacketsInQueue, q, stream);
+  *stream->GetStream () << Simulator::Now ().GetSeconds () << " backlog " << q->GetNPackets () << "p " << q->GetNBytes () << "b " << " dropped "
+                        << q->GetStats ().nTotalDroppedPackets << "p " << q->GetStats ().nTotalDroppedBytes << "b " << std::endl;
+}
+
+#ifdef HAVE_NETMAP_USER_H
+void
+Inflight (Ptr<NetmapNetDevice> dev, Ptr<OutputStreamWrapper> stream)
+{
+  Simulator::Schedule (Seconds (0.001), &Inflight, dev, stream);
+  *stream->GetStream () << dev->GetBytesInNetmapTxRing () << std::endl;
+}
+#endif
+
+int
+main (int argc, char *argv[])
+{
+  NS_LOG_INFO ("Traffic Control Emulation Example");
+
+  std::string deviceName0 ("enx503f56005a2a");
+  std::string deviceName1 ("eno1");
+  std::string ip0 ("10.0.1.2");
+  std::string ip1 ("10.0.2.1");
+  std::string mask0 ("255.255.255.0");
+  std::string mask1 ("255.255.255.0");
+  std::string m0 ("00:00:00:aa:00:01");
+  std::string m1 ("00:00:00:aa:00:02");
+  std::string queueDiscType = "PfifoFast";
+  bool bql = false;
+
+  uint32_t index = 0;
+  bool writer = true;
+#ifdef HAVE_PACKET_H
+  std::string emuMode ("raw");
+#else        // HAVE_NETMAP_USER_H is true (otherwise this example is not compiled)
+  std::string emuMode ("netmap");
+#endif
+
+  CommandLine cmd;
+  cmd.AddValue ("deviceName0", "Device name", deviceName0);
+  cmd.AddValue ("deviceName1", "Device name", deviceName1);
+  cmd.AddValue ("ip0", "Local IP address", ip0);
+  cmd.AddValue ("ip1", "Local IP address", ip1);
+  cmd.AddValue ("mask0", "Local mask", mask0);
+  cmd.AddValue ("mask1", "Local mask", mask1);
+  cmd.AddValue ("m0", "Mac address", m0);
+  cmd.AddValue ("m1", "Mac address", m1);
+  cmd.AddValue ("writer", "Enable write stats", writer);
+  cmd.AddValue ("queueDiscType", "Bottleneck queue disc type in {PfifoFast, ARED, CoDel, FqCoDel, PIE}", queueDiscType);
+  cmd.AddValue ("bql", "Enable byte queue limits on bottleneck netdevice", bql);
+  cmd.AddValue ("index", "Experiment index", index);
+  cmd.AddValue ("emuMode", "Emulation mode in {raw, netmap}", emuMode);
+  cmd.Parse (argc, argv);
+
+  Ipv4Address localIp0 (ip0.c_str ());
+  Ipv4Address localIp1 (ip1.c_str ());
+  Ipv4Mask netmask0 (mask0.c_str ());
+  Ipv4Mask netmask1 (mask1.c_str ());
+  Mac48AddressValue mac0 (m0.c_str ());
+  Mac48AddressValue mac1 (m1.c_str ());
+
+  //
+  // Since we are using a real piece of hardware we need to use the realtime
+  // simulator.
+  //
+  GlobalValue::Bind ("SimulatorImplementationType", StringValue ("ns3::RealtimeSimulatorImpl"));
+
+  //
+  // Since we are going to be talking to real-world machines, we need to enable
+  // calculation of checksums in our protocols.
+  //
+  GlobalValue::Bind ("ChecksumEnabled", BooleanValue (true));
+
+  //
+  // In such a simple topology, the use of the helper API can be a hindrance
+  // so we drop down into the low level API and do it manually.
+  //
+  // First we need a single node.
+  //
+  NS_LOG_INFO ("Create Node");
+  Ptr<Node> node = CreateObject<Node> ();
+
+  //
+  // Create an emu device, allocate a MAC address and point the device to the
+  // Linux device name.  The device needs a transmit queueing discipline so
+  // create a droptail queue and give it to the device.  Finally, "install"
+  // the device into the node.
+  //
+  // Do understand that the ns-3 allocated MAC address will be sent out over
+  // your network since the emu net device will spoof it.  By default, this
+  // address will have an Organizationally Unique Identifier (OUI) of zero.
+  // The Internet Assigned Number Authority IANA
+  //
+  //  http://www.iana.org/assignments/ethernet-numberslocalIp
+  //
+  // reports that this OUI is unassigned, and so should not conflict with
+  // real hardware on your net.  It may raise all kinds of red flags in a
+  // real environment to have packets from a device with an obviously bogus
+  // OUI flying around.  Be aware.
+  //
+
+  NS_LOG_INFO ("Create Devices");
+
+  FdNetDeviceHelper *helper0 = nullptr;
+  FdNetDeviceHelper *helper1 = nullptr;
+
+#ifdef HAVE_PACKET_H
+  if (emuMode == "raw")
+    {
+      EmuFdNetDeviceHelper *raw0 = new EmuFdNetDeviceHelper;
+      raw0->SetDeviceName (deviceName0);
+      helper0 = raw0;
+
+      EmuFdNetDeviceHelper *raw1 = new EmuFdNetDeviceHelper;
+      raw1->SetDeviceName (deviceName1);
+      helper1 = raw1;
+    }
+#endif
+#ifdef HAVE_NETMAP_USER_H
+  if (emuMode == "netmap")
+    {
+      NetmapNetDeviceHelper *netmap0 = new NetmapNetDeviceHelper;
+      netmap0->SetDeviceName (deviceName0);
+      helper0 = netmap0;
+
+      NetmapNetDeviceHelper *netmap1 = new NetmapNetDeviceHelper;
+      netmap1->SetDeviceName (deviceName1);
+      helper1 = netmap1;
+    }
+#endif
+
+  if ((helper0 == nullptr) || (helper1 == nullptr))
+    {
+      NS_ABORT_MSG (emuMode << " not supported.");
+    }
+
+  NetDeviceContainer devices0 = helper0->Install (node);
+  NetDeviceContainer devices1 = helper1->Install (node);
+
+  Ptr<NetDevice> device0 = devices0.Get (0);
+  device0->SetAttribute ("Address", mac0);
+
+  Ptr<NetDevice> device1 = devices1.Get (0);
+  device1->SetAttribute ("Address", mac1);
+
+  //
+  // Add a default internet stack to the node.  This gets us the ns-3 versions
+  // of ARP, IPv4, ICMP, UDP and TCP.
+  //
+  NS_LOG_INFO ("Add Internet Stack");
+  InternetStackHelper internetStackHelper;
+  internetStackHelper.Install (node);
+
+  Ptr<Ipv4> ipv4 = node->GetObject<Ipv4> ();
+
+  NS_LOG_INFO ("Create IPv4 Interface 0");
+  uint32_t interface0 = ipv4->AddInterface (device0);
+  Ipv4InterfaceAddress address0 = Ipv4InterfaceAddress (localIp0, netmask0);
+  ipv4->AddAddress (interface0, address0);
+  ipv4->SetMetric (interface0, 0);
+  ipv4->SetForwarding (interface0, true);
+  ipv4->SetUp (interface0);
+
+  NS_LOG_INFO ("Create IPv4 Interface 1");
+  uint32_t interface1 = ipv4->AddInterface (device1);
+  Ipv4InterfaceAddress address1 = Ipv4InterfaceAddress (localIp1, netmask1);
+  ipv4->AddAddress (interface1, address1);
+  ipv4->SetMetric (interface1, 0);
+  ipv4->SetForwarding (interface1, true);
+  ipv4->SetUp (interface1);
+
+  Ipv4GlobalRoutingHelper::PopulateRoutingTables ();
+
+  // Traffic control configurations
+  // Access link side
+  TrafficControlHelper tch0;
+  tch0.SetRootQueueDisc ("ns3::PfifoFastQueueDisc", "MaxSize", StringValue ("1000p"));
+  tch0.Install (devices0);
+
+  // Bottleneck link side
+  TrafficControlHelper tch1;
+
+  if (queueDiscType.compare ("PfifoFast") == 0)
+    {
+      tch1.SetRootQueueDisc ("ns3::PfifoFastQueueDisc", "MaxSize", StringValue ("1000p"));
+    }
+  else if (queueDiscType.compare ("ARED") == 0)
+    {
+      tch1.SetRootQueueDisc ("ns3::RedQueueDisc");
+      Config::SetDefault ("ns3::RedQueueDisc::ARED", BooleanValue (true));
+      Config::SetDefault ("ns3::RedQueueDisc::MaxSize",
+                          QueueSizeValue (QueueSize (QueueSizeUnit::BYTES, 1000000)));
+      Config::SetDefault ("ns3::RedQueueDisc::MeanPktSize", UintegerValue (1000));
+      Config::SetDefault ("ns3::RedQueueDisc::LinkBandwidth", StringValue ("100Mbps"));
+      Config::SetDefault ("ns3::RedQueueDisc::MinTh", DoubleValue (83333));
+      Config::SetDefault ("ns3::RedQueueDisc::MinTh", DoubleValue (250000));
+    }
+  else if (queueDiscType.compare ("CoDel") == 0)
+    {
+      tch1.SetRootQueueDisc ("ns3::CoDelQueueDisc");
+    }
+  else if (queueDiscType.compare ("FqCoDel") == 0)
+    {
+      tch1.SetRootQueueDisc ("ns3::FqCoDelQueueDisc");
+    }
+  else if (queueDiscType.compare ("PIE") == 0)
+    {
+      tch1.SetRootQueueDisc ("ns3::PieQueueDisc");
+      Config::SetDefault ("ns3::PieQueueDisc::MaxSize",
+                          QueueSizeValue (QueueSize (QueueSizeUnit::PACKETS, 1000)));
+      Config::SetDefault ("ns3::PieQueueDisc::QueueDelayReference", TimeValue (Seconds (0.02)));
+      Config::SetDefault ("ns3::PieQueueDisc::Tupdate", TimeValue (Seconds (0.032)));
+      Config::SetDefault ("ns3::PieQueueDisc::A", DoubleValue (2));
+      Config::SetDefault ("ns3::PieQueueDisc::B", DoubleValue (20));
+    }
+  else
+    {
+      NS_ABORT_MSG ("--queueDiscType not valid");
+    }
+
+  if (bql)
+    {
+      tch1.SetQueueLimits ("ns3::DynamicQueueLimits");
+    }
+
+  QueueDiscContainer qdiscs = tch1.Install (devices1);
+  Ptr<QueueDisc> q = qdiscs.Get (0);
+
+  if (writer)
+    {
+      AsciiTraceHelper ascii;
+      Ptr<OutputStreamWrapper> stream = ascii.CreateFileStream ("exp-" + std::to_string (index) + "-router-tc-stats.txt");
+      Simulator::Schedule (Seconds (0.001), &TcPacketsInQueue, q, stream);
+
+#ifdef HAVE_NETMAP_USER_H
+      if (emuMode.compare ("netmap") == 0)
+        {
+          Ptr<NetmapNetDevice> dev = StaticCast <NetmapNetDevice> (device1);
+          Ptr<OutputStreamWrapper> stream2 = ascii.CreateFileStream ("exp-" + std::to_string (index) + "-router-inflight.txt");
+          Simulator::Schedule (Seconds (0.001), &Inflight, dev, stream2);
+        }
+#endif
+
+      Ipv4GlobalRoutingHelper g;
+      Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> ("router-routes.txt", std::ios::out);
+      g.PrintRoutingTableAllAt (Seconds (3), routingStream);
+    }
+
+  NS_LOG_INFO ("Run Emulation.");
+  Simulator::Stop (Seconds (50.0));
+  Simulator::Run ();
+  Simulator::Destroy ();
+  delete helper0;
+  delete helper1;
+  NS_LOG_INFO ("Done.");
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/examples/wscript ns-3.32/src/fd-net-device/examples/wscript
--- ns-3.31/src/fd-net-device/examples/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/fd-net-device/examples/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -16,13 +16,19 @@
         obj = bld.create_ns3_program('realtime-fd2fd-onoff', ['fd-net-device', 'internet', 'applications'])
         obj.source = 'realtime-fd2fd-onoff.cc'
 
-    if bld.env['ENABLE_TAP']:
+    if bld.env['ENABLE_EMU' or 'ENABLE_NETMAP_EMU' or 'ENABLE_DPDKNETDEV']:
         obj = bld.create_ns3_program('fd-emu-ping', ['fd-net-device', 'internet', 'internet-apps'])
         obj.source = 'fd-emu-ping.cc'
-        obj = bld.create_ns3_program('fd-emu-udp-echo', ['fd-net-device', 'internet', 'applications'])
-        obj.source = 'fd-emu-udp-echo.cc'
         obj = bld.create_ns3_program('fd-emu-onoff', ['fd-net-device', 'internet', 'applications'])
         obj.source = 'fd-emu-onoff.cc'
+        obj = bld.create_ns3_program('fd-emu-tc', ['fd-net-device', 'internet', 'internet-apps', 'applications', 'traffic-control'])
+        obj.source = 'fd-emu-tc.cc'
+        obj = bld.create_ns3_program('fd-emu-send', ['fd-net-device', 'internet', 'internet-apps', 'applications', 'traffic-control'])
+        obj.source = 'fd-emu-send.cc'
+
+    if bld.env['ENABLE_EMU']:
+        obj = bld.create_ns3_program('fd-emu-udp-echo', ['fd-net-device', 'internet', 'applications'])
+        obj.source = 'fd-emu-udp-echo.cc'
 
     if bld.env['ENABLE_TAP']:
         obj = bld.create_ns3_program('fd-tap-ping', ['fd-net-device', 'internet', 'internet-apps'])
@@ -33,4 +39,3 @@
     if bld.env['ENABLE_PLANETLAB']:
         obj = bld.create_ns3_program('fd-planetlab-ping', ['fd-net-device', 'internet', 'internet-apps'])
         obj.source = 'fd-planetlab-ping.cc'
-
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/helper/dpdk-net-device-helper.cc ns-3.32/src/fd-net-device/helper/dpdk-net-device-helper.cc
--- ns-3.31/src/fd-net-device/helper/dpdk-net-device-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/fd-net-device/helper/dpdk-net-device-helper.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,94 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Harsh Patel <thadodaharsh10@gmail.com>
+ *          Hrishikesh Hiraskar <hrishihiraskar@gmail.com>
+ */
+
+#include "dpdk-net-device-helper.h"
+
+#include "ns3/dpdk-net-device.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("DpdkNetDeviceHelper");
+
+DpdkNetDeviceHelper::DpdkNetDeviceHelper ()
+  : m_lCoreList ("0,1"),
+    m_pmdLibrary ("librte_pmd_e1000.so"),
+    m_dpdkDriver ("uio_pci_generic")
+{
+  NS_LOG_FUNCTION (this);
+  SetTypeId ("ns3::DpdkNetDevice");
+}
+
+void
+DpdkNetDeviceHelper::SetLCoreList (std::string lCoreList)
+{
+  m_lCoreList = lCoreList;
+}
+
+void
+DpdkNetDeviceHelper::SetPmdLibrary (std::string pmdLibrary)
+{
+  m_pmdLibrary = pmdLibrary;
+}
+
+void
+DpdkNetDeviceHelper::SetDpdkDriver (std::string dpdkDriver)
+{
+  m_dpdkDriver = dpdkDriver;
+}
+
+Ptr<NetDevice>
+DpdkNetDeviceHelper::InstallPriv (Ptr<Node> node) const
+{
+  NS_LOG_FUNCTION (this);
+  Ptr<NetDevice> device = FdNetDeviceHelper::InstallPriv (node);
+  Ptr<DpdkNetDevice> dpdkDevice = DynamicCast<DpdkNetDevice> (device);
+  dpdkDevice->SetDeviceName (m_deviceName);
+
+  // Set EAL arguments
+  char **ealArgv = new char*[20];
+
+  // arg[0] is program name (optional)
+  ealArgv[0] = new char[20];
+  strcpy (ealArgv[0], "");
+
+  // Logical core usage
+  ealArgv[1] = new char[20];
+  strcpy (ealArgv[1], "-l");
+  ealArgv[2] = new char[20];
+  strcpy (ealArgv[2], m_lCoreList.c_str ());
+
+  // Load library
+  ealArgv[3] = new char[20];
+  strcpy (ealArgv[3], "-d");
+  ealArgv[4] = new char[50];
+  strcpy (ealArgv[4], m_pmdLibrary.c_str ());
+
+  // Use mempool ring library
+  ealArgv[5] = new char[20];
+  strcpy (ealArgv[5], "-d");
+  ealArgv[6] = new char[50];
+  strcpy (ealArgv[6], "librte_mempool_ring.so");
+
+  dpdkDevice->InitDpdk (7, ealArgv, m_dpdkDriver);
+  return dpdkDevice;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/helper/dpdk-net-device-helper.h ns-3.32/src/fd-net-device/helper/dpdk-net-device-helper.h
--- ns-3.31/src/fd-net-device/helper/dpdk-net-device-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/fd-net-device/helper/dpdk-net-device-helper.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,99 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Harsh Patel <thadodaharsh10@gmail.com>
+ *          Hrishikesh Hiraskar <hrishihiraskar@gmail.com>
+ */
+
+#ifndef DPDK_NET_DEVICE_HELPER_H
+#define DPDK_NET_DEVICE_HELPER_H
+
+#include "ns3/emu-fd-net-device-helper.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup dpdk-net-device
+ * \brief build a DpdkNetDevice object attached to a physical network
+ * interface
+ *
+ */
+class DpdkNetDeviceHelper : public EmuFdNetDeviceHelper
+{
+public:
+  /**
+   * Construct a DpdkNetDeviceHelper and initialize DPDK EAL
+   *
+   * \param argc Dpdk EAL args count.
+   * \param argv Dpdk EAL args list.
+   */
+  DpdkNetDeviceHelper ();
+
+  virtual ~DpdkNetDeviceHelper ()
+  {}
+
+  /**
+   * \brief Sets list of logical cores to use
+   *
+   * \param lCoreList Comma separated logical core list (e.g., "0,1")
+   */
+  void SetLCoreList (std::string lCoreList);
+
+  /**
+   * \brief Sets PMD Library to be used for the NIC
+   *
+   * \param pmdLibrary The PMD Library
+   */
+  void SetPmdLibrary (std::string pmdLibrary);
+
+  /**
+   * \brief Sets DPDK Driver to bind NIC to
+   *
+   * \param dpdkDriver The DPDK Driver
+   */
+  void SetDpdkDriver (std::string dpdkDriver);
+
+protected:
+  /**
+   * \brief This method creates an ns3::FdNetDevice attached to a physical network
+   * interface
+   *
+   * \param node The node to install the device in
+   * \returns A container holding the added net device.
+   */
+  Ptr<NetDevice> InstallPriv (Ptr<Node> node) const;
+
+  /**
+   * Logical cores to use
+   */
+  std::string m_lCoreList;
+
+  /**
+   * PMD Library to be used for NIC
+   */
+  std::string m_pmdLibrary;
+
+  /**
+   * DPDK Driver to bind NIC to
+   */
+  std::string m_dpdkDriver;
+
+};
+
+} // namespace ns3
+
+#endif /* DPDK_NET_DEVICE_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/helper/emu-fd-net-device-helper.cc ns-3.32/src/fd-net-device/helper/emu-fd-net-device-helper.cc
--- ns-3.31/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2020-10-06 15:35:43.000000000 -0700
@@ -62,6 +62,7 @@
 EmuFdNetDeviceHelper::EmuFdNetDeviceHelper ()
 {
   m_deviceName = "undefined";
+  m_hostQdiscBypass = false;
 }
 
 void
@@ -70,6 +71,12 @@
   m_deviceName = deviceName;
 }
 
+void
+EmuFdNetDeviceHelper::HostQdiscBypass (bool hostQdiscBypass)
+{
+  m_hostQdiscBypass = hostQdiscBypass;
+}
+
 std::string
 EmuFdNetDeviceHelper::GetDeviceName (void)
 {
@@ -140,6 +147,23 @@
       NS_FATAL_ERROR ("EmuFdNetDeviceHelper::SetFileDescriptor (): Can't get interface flags");
     }
 
+  if (m_hostQdiscBypass)
+    {
+#ifdef PACKET_QDISC_BYPASS
+      static const int32_t sock_qdisc_bypass = 1;
+      int32_t sock_qdisc_ret = setsockopt (fd, SOL_PACKET, PACKET_QDISC_BYPASS, &sock_qdisc_bypass,
+                                           sizeof (sock_qdisc_bypass));
+
+      if (sock_qdisc_ret == -1)
+        {
+          NS_LOG_ERROR ("Cannot use the qdisc bypass option");
+        }
+#else
+      // PACKET_QDISC_BYPASS is defined since Linux 3.14
+      NS_LOG_ERROR ("PACKET_QDISC_BYPASS undefined; cannot use the qdisc bypass option");
+#endif
+    }
+
   //
   // This device only works if the underlying interface is up in promiscuous
   // mode.  We could have turned it on in the socket creator, but the situation
@@ -173,7 +197,7 @@
 
   // Set the MTU of the device to the mtu of the associated network interface
   struct ifreq ifr2;
-  
+
   bzero (&ifr2, sizeof (ifr2));
   strcpy (ifr2.ifr_name, m_deviceName.c_str ());
 
@@ -184,7 +208,7 @@
     {
       NS_FATAL_ERROR ("FdNetDevice::SetFileDescriptor (): Can't ioctl SIOCGIFMTU");
     }
- 
+
   close (mtufd);
   device->SetMtu (ifr2.ifr_mtu);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/helper/emu-fd-net-device-helper.h ns-3.32/src/fd-net-device/helper/emu-fd-net-device-helper.h
--- ns-3.31/src/fd-net-device/helper/emu-fd-net-device-helper.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/fd-net-device/helper/emu-fd-net-device-helper.h	2020-10-06 15:35:43.000000000 -0700
@@ -45,8 +45,7 @@
    */
   EmuFdNetDeviceHelper ();
   virtual ~EmuFdNetDeviceHelper ()
-  {
-  }
+  {}
 
   /**
    * Get the device name of this device.
@@ -62,6 +61,12 @@
    */
   void SetDeviceName (std::string deviceName);
 
+  /**
+   * \brief Request host qdisc bypass
+   * \param hostQdiscBypass to enable host qdisc bypass
+   */
+  void HostQdiscBypass (bool hostQdiscBypass);
+
 protected:
 
   /**
@@ -86,9 +91,10 @@
   virtual int CreateFileDescriptor (void) const;
 
   /**
-   * The unix/linux name of the underlying device (e.g., eth0)
+   * The Unix/Linux name of the underlying device (e.g., eth0)
    */
   std::string m_deviceName;
+  bool m_hostQdiscBypass;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/helper/fd-net-device-helper.cc ns-3.32/src/fd-net-device/helper/fd-net-device-helper.cc
--- ns-3.31/src/fd-net-device/helper/fd-net-device-helper.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/fd-net-device/helper/fd-net-device-helper.cc	2020-10-06 15:35:43.000000000 -0700
@@ -43,6 +43,12 @@
 }
 
 void
+FdNetDeviceHelper::SetTypeId (std::string type)
+{
+  m_deviceFactory.SetTypeId (type);
+}
+
+void
 FdNetDeviceHelper::SetAttribute (std::string n1, const AttributeValue &v1)
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/helper/fd-net-device-helper.h ns-3.32/src/fd-net-device/helper/fd-net-device-helper.h
--- ns-3.31/src/fd-net-device/helper/fd-net-device-helper.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/fd-net-device/helper/fd-net-device-helper.h	2020-10-06 15:35:43.000000000 -0700
@@ -55,6 +55,13 @@
   }
 
   /**
+   * Set the TypeId of the Objects to be created by this helper.
+   *
+   * \param [in] tid The TypeId of the object to instantiate.
+   */
+  void SetTypeId (std::string type);
+
+  /**
    * \param n1 the name of the attribute to set
    * \param v1 the value of the attribute to set
    *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/helper/netmap-device-creator.cc ns-3.32/src/fd-net-device/helper/netmap-device-creator.cc
--- ns-3.31/src/fd-net-device/helper/netmap-device-creator.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/fd-net-device/helper/netmap-device-creator.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,95 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include <unistd.h>
+#include <string>
+#include <iostream>
+#include <iomanip>
+#include <sstream>
+#include <stdlib.h>
+#include <errno.h>
+#include <fcntl.h>
+
+#include <sys/socket.h>
+#include <sys/un.h>
+#include <sys/ioctl.h>
+#include <net/ethernet.h>
+#include <net/if.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include "creator-utils.h"
+
+#define EMU_MAGIC 65867
+
+using namespace ns3;
+
+int
+main (int argc, char *argv[])
+{
+  int c;
+  char *path = NULL;
+
+  opterr = 0;
+
+  while ((c = getopt (argc, argv, "vp:")) != -1)
+    {
+      switch (c)
+        {
+          case 'v':
+            gVerbose = true;
+            break;
+          case 'p':
+            path = optarg;
+            break;
+        }
+    }
+
+  //
+  // This program is spawned by an emu net device running in a simulation.  It
+  // wants to create a raw socket as described below.  We are going to do the
+  // work here since we're running suid root.  Once we create the raw socket,
+  // we have to send it back to the emu net device.  We do that over a Unix
+  // (local interprocess) socket.  The emu net device created a socket to
+  // listen for our response on, and it is expected to have encoded the address
+  // information as a string and to have passed that string as an argument to
+  // us.  We see it here as the "path" string.  We can't do anything useful
+  // unless we have that string.
+  //
+  ABORT_IF (path == NULL, "path is a required argument", 0);
+  LOG ("Provided path is \"" << path << "\"");
+  //
+  // The whole reason for all of the hoops we went through to call out to this
+  // program will pay off here.  We created this program to run as suid root
+  // in order to keep the main simulation program from having to be run with
+  // root privileges.  We need root privileges to be able to open a raw socket
+  // though.  So all of these hoops are to allow us to execute the following
+  // single line of code:
+  //
+  LOG ("Creating netmap fd");
+  int sock = open ("/dev/netmap", O_RDWR);
+  ABORT_IF (sock == -1, "CreateSocket(): Unable to open netmap fd", 1);
+
+  //
+  // Send the socket back to the emu net device so it can go about its business
+  //
+  SendSocket (path, sock, EMU_MAGIC);
+
+  return 0;
+}
+
